%define name device-mapper
%define version 1.00.07
%define extraversion %{nil}
%define release 2mdk

%define use_dietlibc 0
%ifarch %{ix86} x86_64
%define use_dietlibc 1
%endif

%define _sbindir /sbin
%define major 1.00

# Macro: %%{mklibname <name> [<major> [<minor>]] [-s] [-d]}
%define libname %{mklibname devmapper 1.00}
%define dlibname %{mklibname devmapper 1.00 -d}

Summary: Device mapper
Name: %{name}
Version: %{version}
Release: %{release}
Source0: ftp://ftp.sistina.com/pub/LVM2/device-mapper/%{name}.%{version}%{extraversion}.tar.bz2
Patch0: device-mapper-1.00.05-diet.patch.bz2
License: GPL
Group: System/Kernel and hardware
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %{_prefix}
URL: http://www.sistina.com/lvm
%if %{use_dietlibc}
BuildRequires: dietlibc-devel
%endif

%description
The goal of this driver is to support volume management.  
The driver enables the definition of new block devices composed of
ranges of sectors of existing devices.  This can be used to define
disk partitions - or logical volumes.  This light-weight kernel
component can support user-space tools for logical volume management.

%package -n dmsetup
Summary: Device mapper setup tool
Group: System/Kernel and hardware
Provides: device-mapper = %{version}-%{release}
Requires: %{libname} = %{version}-%{release}
%description -n dmsetup
The goal of this driver is to support volume management.  
The driver enables the definition of new block devices composed of
ranges of sectors of existing devices.  This can be used to define
disk partitions - or logical volumes.  This light-weight kernel
component can support user-space tools for logical volume management.

%package -n %{mklibname devmapper 1.00}
Summary: Device mapper library
Group: System/Kernel and hardware
%description -n %{libname}
The goal of this driver is to support volume management.  
The driver enables the definition of new block devices composed of
ranges of sectors of existing devices.  This can be used to define
disk partitions - or logical volumes.  This light-weight kernel
component can support user-space tools for logical volume management.

%package -n %{dlibname}
Summary: Device mapper development library
Group: Development/C
Provides: device-mapper-devel = %{version}-%{release}
Provides: libdevmapper-devel = %{version}-%{release}
Requires: %{libname} = %{version}-%{release}
%description -n %{dlibname}
The goal of this driver is to support volume management.  
The driver enables the definition of new block devices composed of
ranges of sectors of existing devices.  This can be used to define
disk partitions - or logical volumes.  This light-weight kernel
component can support user-space tools for logical volume management.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n %{name}.%{version}%{extraversion}
%patch0 -p1 -b .diet

%build
%configure --with-user=`id -un` --with-group=`id -gn`
%make include

%make -C lib PIC= ioctl/libdevmapper.o libdm-common.o
ar -cr lib/libdevmapper.a lib/*.o lib/*/*.o

%if %{use_dietlibc}
%make clean
%make -C lib CC="diet gcc" PIC= ioctl/libdevmapper.o libdm-common.o
ar -cr lib/libdevmapper-diet.a lib/*.o lib/*/*.o
%endif

%make clean
%make


%install
%makeinstall
mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv $RPM_BUILD_ROOT%{_libdir}/libdevmapper.so.* $RPM_BUILD_ROOT/%{_lib}
ln -sf /%{_lib}/libdevmapper.so.%{major} $RPM_BUILD_ROOT%{_libdir}/libdevmapper.so
cp lib/libdevmapper.a $RPM_BUILD_ROOT%{_libdir}
%if %{use_dietlibc}
cp lib/libdevmapper-diet.a $RPM_BUILD_ROOT%{_libdir}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files -n dmsetup
%defattr(644,root,root,755)
%doc INSTALL INTRO README VERSION
%doc patches/*.patch
%doc scripts/*
%attr(755,root,root) %{_sbindir}/dmsetup
%{_mandir}/man8/dmsetup.8*

%files -n %{libname}
%defattr(755,root,root)
/%{_lib}/libdevmapper.so.*

%files -n %{dlibname}
%defattr(644,root,root,755)
%{_libdir}/libdevmapper.*
%{_includedir}/libdevmapper.h
%if %{use_dietlibc}
%{_libdir}/libdevmapper-diet.*
%endif

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%changelog
* Fri Dec 19 2003 Luca Berra <bluca@vodka.it> 1.00.07-2mdk
- i discovered --disable-compat to configure actually enables it
- put library in %%{_lib}
- fix permissions

* Sat Nov 22 2003 Luca Berra <bluca@vodka.it> 1.00.07-1mdk
- 1.00.07
- dmsetup requires same version of library
- correct provides for development library

* Thu Nov 20 2003 Luca Berra <bluca@vodka.it> 1.00.05-2mdk
- provide dietlibc version for building lvm2 tools

* Sat Sep 06 2003 Luca Berra <bluca@vodka.it> 1.00.05-1mdk
- 1.00.05

* Wed Aug 27 2003 Luca Berra <bluca@vodka.it> 1.00.01-0.rc2.1mdk
- 1.00.04
- mdk uses bz2

* Wed Jul 16 2003 Luca Berra <bluca@vodka.it> 1.00.01-0.rc2.1mdk
- 1.00.01-rc2

* Sun Dec  1 2002 Luca Berra <bluca@vodka.it> 0.96.07-1mdk
- 0.96.07

* Sat Jun  1 2002 Luca Berra <bluca@vodka.it> 0.95.11-1mdk
- 0.95.11
